<template>
    <v-container>
        <v-card>
            <v-layout column align-center>
                <v-card-title primary-title class="title cart-title">
                    Dados cadastrais
                </v-card-title>
                <v-container>
                <v-form ref="form"
                v-model="valid">
                <v-layout>
                    <v-flex xs12>
                        <span class="body-2 card-title">Informações pessoais</span>
                    </v-flex>
                </v-layout>
                <v-layout wrap fluid>
                <v-flex xs12 md12>
                    <v-text-field
                        label="Nome"
                        v-model="information.nome"
                        :rules="[rules.required]"
                        :loading="isLoading"
                        filled
                    ></v-text-field>   
                </v-flex>          

                <v-flex xs12 md12>
                    <v-text-field
                    label="Telefone"
                    v-model="information.telefone"
                    :rules="[rules.required, rules.valid_phone]"
                    v-mask="tel"
                    :loading="isLoading"
                    :disabled="isLoading"
                    filled
                    ></v-text-field>   
                </v-flex>   
                </v-layout>
                
                <v-flex xs12 md12>
                <v-text-field
                    label="Sexo"
                    v-model="information.sexo"
                    :rules="[rules.required]"
                    :loading="isLoading"
                    disabled
                    filled
                ></v-text-field>
                </v-flex>

                <v-flex xs12 md12>
                <v-text-field
                    label="E-mail"
                    v-model="information.email"
                    :rules="[rules.required, rules.email]"
                    :loading="isLoading"
                    :disabled="isLoading"
                    filled
                ></v-text-field>
                </v-flex>

                <v-flex xs12 md12>
                <v-text-field
                    label="CPF"
                    v-model="information.cpf"
                    :rules="[rules.required, rules.valid_cpf]"
                    mask="###.###.###-##"
                    :loading="isLoading"
                    disabled
                    pattern="\d*"
                    filled
                ></v-text-field>
                </v-flex>

                <v-flex xs12 md12>
                <v-text-field
                    label="Nascimento"
                    v-model="information.data_nascimento"
                    :rules="[rules.required]"
                    v-mask="birthday"
                    :loading="isLoading"
                    :disabled="isLoading"
                    pattern="\d*"
                    @click="newDate()"
                    filled
                ></v-text-field>
                </v-flex>

                <v-flex xs12 md4>
                    <v-btn block color="primary" @click="check">
                        Alterar Dados
                    </v-btn>
                </v-flex>
                </v-form>

                    <v-dialog v-model="dialog" persistent max-width="290">
                        <v-card>
                            <v-card-title class="headline">Código enviado!</v-card-title>
                            <v-card-text>
                                Por favor, dê uma olhada na sua caixa de SMS do seu celular e na caixa de e-mail.
                                <v-spacer></v-spacer>
                                <v-flex xs12 sm6 md3>
                                    <v-text-field
                                        v-model="information.code"
                                        label="Código de Verificação"
                                    ></v-text-field>
                                </v-flex>
                            </v-card-text>
                            <v-card-actions>
                                <v-btn block color="primary" text @click="verify">Verificar</v-btn>
                            </v-card-actions>
                        </v-card>
                    </v-dialog>
            </v-container>
        </v-layout>
        </v-card>
    </v-container>
</template>

<script>
import moment from 'moment'

  export default {
      directives: {
          birthday: '##/##/####',
          tel: '(##) #####-####'
      },
    methods: {
        checkPassword() {
            if (this.information.password === '' || this.information.password != this.information.cpassword) {
                return false
            } else {
               return true
            }
        },
    limpaForm () {
      this.information.data_nascimento = ''
    },
      newDate() {
        this.limpaForm()
        let d = this.information.data_nascimento;
        if (this.information.data_nascimento.length === 8) {
            console.log('deu bom')
        //   let novo = `${d[0]}${d[1]}/${d[2]}${d[3]}/${d[4]}${d[5]}${d[6]}${
        //     d[7]
        //   }`;
        //   this.information.data_nascimento = novo;
        }
      },
      checkCPF: function() {
        const cpf = this.information.cpf;
        if (
          cpf.length != 11 ||
          cpf == "00000000000" ||
          cpf == "11111111111" ||
          cpf == "22222222222" ||
          cpf == "33333333333" ||
          cpf == "44444444444" ||
          cpf == "55555555555" ||
          cpf == "66666666666" ||
          cpf == "77777777777" ||
          cpf == "88888888888" ||
          cpf == "99999999999"
        )
          return false;
        let add = 0;
        let i;
        let rev;
        for (i = 0; i < 9; i++) add += parseInt(cpf.charAt(i)) * (10 - i);
        rev = 11 - (add % 11);
        if (rev == 10 || rev == 11) rev = 0;
        if (rev != parseInt(cpf.charAt(9))) return false;
        add = 0;
        for (i = 0; i < 10; i++) add += parseInt(cpf.charAt(i)) * (11 - i);
        rev = 11 - (add % 11);
        if (rev == 10 || rev == 11) rev = 0;
        if (rev != parseInt(cpf.charAt(10))) return false;
        return true;
      },
        loadAddressFromCEP() {
        this.cepLoading = true;
        this.$viaCep.buscarCep(this.information.cep).then(response => {
            console.log(response)
          const data = response;
          this.information.endereco = data.logradouro;
          this.information.cidade = data.localidade;
          this.information.bairro = data.bairro;
          this.information.uf_sigla = data.uf;
          this.information.codigo_ibge = data.ibge;
          this.novo_cep = data.cep;

          this.cepLoading = false;
        });
      },
      newCep() {
        // let d = this.information.address.cep;
        if (this.information.cep.length === 8) {
          this.loadAddressFromCEP();
        //   let novo = `${d[0]}${d[1]}${d[2]}${d[3]}${d[4]}-${d[5]}${d[6]}${
        //     d[7]
        //   }`;
        //   console.log(novo, "NEW CEP");
        //   this.novo_cep = novo;
        }
      },
        showAlert(){
            // Use sweetalert2
            this.$swal(
                "Dados alterados com sucesso!",
                "Reinicie o aplicativo (feche e abra novamente).",
                "success"
            );
        },
        check() {
            if(this.$refs.form.validate()){
                this.$axios.post(`${this.$store.state.api}twilio`, {
                    telefone: this.information.telefone,
                    email: this.information.email,
                    cpf: this.information.cpf
                }).then((res) => {
                    if(res.status == 200) {
                        this.isLoading = true
                        this.dialog = true
                    }
                })
                .catch((error) => {
                    console.log(error.response)
                    if (error.response.status === 401) {
                        this.$swal({
                            type: 'error',
                            title: 'Ops...',
                            text: error.response.data.message
                        }).then((res) => {
                        if (res.value) {
                            action.performClick('close')
                        }
                    })
                    } else if (error.response.status === 500) {
                        this.$swal({
                            type: 'error',
                            title: 'Tente novamente',
                            text: 'Verifique a sua conexão com a internet e se o código enviado para o seu celular está válido.'
                        })                        
                    }

                });

            } else {
                this.$swal({
                    type: 'warning',
                    title: 'Preencha todos os campos',
                    text: 'Você pode ter esquecido algum campo ou suas senhas não condizem'
                });
            }
        },
        verify() {
            let datalog = {
                cpf: this.information.cpf,
                data_nascimento: this.information.data_nascimento,
                email: this.information.email,
                groupUser: this.group,
                nome: this.information.nome,
                sexo: this.information.sexo,
                telefone: this.information.telefone,
                code: this.information.code
            }
            this.$axios.put(`${this.$store.state.api}form/update/${this.$store.state.uid}`, this.information).then((res) => {
                if (res.status == 200) {
                    this.$swal({
                        type: 'success',
                        title: 'Dados alterados com sucesso!',
                        text: 'Reinicie o aplicativo (feche e abra novamente).'
                    }).then((res) => {
                        if (res.value) {
                            action.performClick('close')
                        }
                    })
                }
            }).catch((error) =>{
                this.$swal({
                    type: 'error',
                    title: 'Tente novamente',
                    text: 'Verifique a sua conexão com a internet e se o código enviado para o seu celular está válido.'
                })
          })
        }
    },
    mounted() {
        /**
         * get birthdate string and format with momentjs to pt-br format
         */
        moment.locale('pt-br')
        const birthdate = this.$store.state.user.data_nascimento
        var curr = moment(birthdate).format('L')
        this.information.data_nascimento = curr
    },
    data() {
        return {
            sexoItems: [
            { text: "M", value: "MASCULINO" },
            { text: "F", value: "FEMININO" }
            ],
            information: {
                nome: this.$store.state.user.nome,
                email: this.$store.state.user.email,
                telefone: this.$store.state.user.telefone, 
                cpf: this.$store.state.user.cpf, 
                data_nascimento: this.$store.state.user.data_nascimento,
                sexo: this.$store.state.user.sexo,
                group: 3,
                code: null,
            },
            feedback: 'Você precisa preencher todos os campos',
            birthday: '##/##/####',
            tel: '(##) #####-####',
            dialog: false,
            cepLoading: false,
            resetPassword: false,
            password: "",
            cpassword: "",
            showPassword: false,
            isLoading: false,
            valid: true,
            checkbox: false,
            lazy: false,
            rules: {
                valid_cpf: input => {
                    return !this.checkCPF() || 'O CPF informado é inválido';
                },
                valid_phone: input => {
                    return input.length >= 10 || 'Por favor, informe um número de telefone válido.';
                },
                required: input => {
                    return input !== "" || 'Por favor, informe esse campo.';
                },
                email: input => {
                    const re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
                    return !re.test(String(input).toLowerCase())
                    ? "E-mail é inválido."
                    : true;
                },
            },
            dialog: false
        }
    }
  }
</script>

<style>
    .card-title {
        color: #1a75ce;
        font-weight: 500;
    }
</style>
